Name:           obs-studio
Version:        18.0.1
Release:        2%{?dist}
Summary:        Open Broadcaster Software Studio

License:        GPLv2+
URL:            https://obsproject.com/
#Source0:        https://github.com/jp9000/obs-studio/archive/%{version}.tar.gz
Source0:        https://github.com/jp9000/obs-studio/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
Patch0:         obs-ffmpeg-mux.patch

# Arm gcc has no xmmintrin.h file
ExclusiveArch:  i686 x86_64

%define systemd %{nil}
%if 0%{?rhel}%{?fedora}
  %if 0%{?rhel}
    %if 0%{?rhel} >= 7
      %define systemd 1
    %endif
  %else #%if 0%{?fedora}
    %if 0%{?fedora} >= 18
      %define systemd 1
    %endif
  %endif
%else
  %if 0%{?suse_version}
    %if 0%{?suse_version} >= 1140
      %define systemd 1
    %endif
  %endif
%endif

%define use_cmake3 %{nil}
%if 0%{?rhel}%{?fedora}
  %if 0%{?rhel}
    %if 0%{?rhel} <= 7
      %define use_cmake3 1
    %endif
  %else #%if 0%{?fedora}
    %if 0%{?fedora} <= 18
      %define use_cmake3 1
    %endif
  %endif
%endif

%define cmd_cmake cmake
%if 0%{?use_cmake3}
  %define cmd_cmake cmake3
%endif

#%{!?_cmake3_lib_suffix64: -DLIB_SUFFIX=64}

#BuildRequires:  cmake >= 2.8.12
%if 0%{?use_cmake3}
BuildRequires:  cmake3 >= 3.0
%else
BuildRequires:  cmake >= 2.8.12
%endif

BuildRequires:  ffmpeg-devel
BuildRequires:  fontconfig-devel
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gcc-objc
BuildRequires:  hicolor-icon-theme
BuildRequires:	libcurl-devel
BuildRequires:  libv4l-devel
BuildRequires:  libXcomposite-devel
BuildRequires:  libXinerama-devel
BuildRequires:  libXrandr-devel

# <new>
# introduced in 18.0.1
#BuildRequires:  alsa-lib-devel
BuildRequires:  doxygen
#BuildRequires:  speexdsp-devel
# from nux-dextop repo
BuildRequires:  vlc-devel
# </new>

%if 0%{?rhel}%{?fedora}
BuildRequires:  desktop-file-utils

BuildRequires:  mesa-libGL-devel
BuildRequires:  libX11-devel

BuildRequires:  freetype-devel
BuildRequires:  jansson-devel
BuildRequires:  pulseaudio-libs-devel
BuildRequires:  qt5-qtbase-devel >= 5.3
BuildRequires:  qt5-qtx11extras-devel >= 5.3
BuildRequires:  x264-devel

BuildRequires:  jack-audio-connection-kit-devel

# <new>
# introduced in 18.0.1
BuildRequires:  alsa-lib-devel
%if 0%{?rhel}
BuildRequires:  speex-devel
%else
BuildRequires:  speexdsp-devel
%endif
# </new>
%else
  %if 0%{?suse_version}
BuildRequires:  freetype2-devel
BuildRequires:  libjansson-devel
BuildRequires:  libpulse-devel
BuildRequires:  libqt5-qtbase-devel >= 5.3
BuildRequires:  libqt5-qtx11extras-devel >= 5.3
BuildRequires:  libx264-devel

BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(jack)

# <new>
# introduced in 18.0.1
BuildRequires:  alsa-devel
BuildRequires:  speexdsp-devel
# </new>
  %endif
%endif

%if 0%{?systemd}
BuildRequires:  systemd-devel
%else
BuildRequires:  libudev-devel
%endif

Requires:       ffmpeg

%if 0%{?rhel}%{?fedora}
Requires:       x264
%else
  %if 0%{?suse_version}
Requires:       libx264
  %endif
%endif

%if 0%{?systemd}
Requires:       systemd-libs
%else
Requires:       libudev
%endif

%description
Open Broadcaster Software is free and open source software for video recording and live streaming.

%package libs
Summary:        Open Broadcaster Software Studio libraries
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description libs
Library files for Open Broadcaster Software

%package devel
Summary:        Open Broadcaster Software Studio header files
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
Header files for Open Broadcaster Software

%package        doc
Summary:        Documentation files for %{name}
Group:          Documentation
BuildArch:      noarch

%description    doc
The %{name}-doc package contains html documentation
that use %{name}.

%prep
%setup -q
%patch0 -p0

# rpmlint reports E: hardcoded-library-path
# replace OBS_MULTIARCH_SUFFIX by LIB_SUFFIX
sed -i 's|OBS_MULTIARCH_SUFFIX|LIB_SUFFIX|g' cmake/Modules/ObsHelpers.cmake

%build
#cmake -DOBS_VERSION_OVERRIDE=%{version}
#cmake3 -DOBS_VERSION_OVERRIDE=%{version} -DUNIX_STRUCTURE=1 -DCMAKE_INSTALL_PREFIX=/usr
%{cmd_cmake} -DUNIX_STRUCTURE=1 \
  -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \
  -DLIB_INSTALL_DIR:PATH=%{_libdir} \
%if "%{?_lib}" == "lib64"
  %{?_cmake3_lib_suffix64} \
%endif
  -DOBS_VERSION_OVERRIDE=%{version}

#make %{?_smp_mflags}
%make_build

# build docs
doxygen

%install
%make_install
#desktop-file-validate %{buildroot}%{_datadir}/applications/obs.desktop

%ifarch x86_64
#mkdir -p %{buildroot}%{_libdir}/obs-plugins
#mv %{buildroot}/usr/lib/libobs*.so* %{buildroot}%{_libdir}
#mv %{buildroot}/usr/lib/cmake %{buildroot}%{_libdir}/
#mv %{buildroot}/usr/lib/debug %{buildroot}%{_libdir}/
#if [[ -d %{buildroot}/usr/lib && ! -d  %{buildroot}%{_libdir} ]]; then
#  mv %{buildroot}/usr/lib %{buildroot}%{_libdir}
#fi
%endif

mkdir -p %{buildroot}/%{_libexecdir}/obs-plugins/obs-ffmpeg/
mv -f %{buildroot}/%{_datadir}/obs/obs-plugins/obs-ffmpeg/ffmpeg-mux \
  %{buildroot}/%{_libexecdir}/obs-plugins/obs-ffmpeg/ffmpeg-mux

%check
#/usr/bin/desktop-file-validate %{buildroot}/%{_datadir}/applications/obs.desktop
desktop-file-validate %{buildroot}/%{_datadir}/applications/obs.desktop

%post
/sbin/ldconfig
update-desktop-database >&/dev/null || :
touch --no-create %{_datadir}/icons/hicolor >&/dev/null || :

%postun
/sbin/ldconfig
update-desktop-database >&/dev/null || :
if [ $1 -eq 0 ]; then
  touch --no-create %{_datadir}/icons/hicolor >&/dev/null || :
  gtk-update-icon-cache %{_datadir}/icons/hicolor >&/dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor >&/dev/null || :

%files
#   %{_bindir}/obs
#   %{_prefix}/lib/cmake/LibObs
#   %{_libdir}/libobs-opengl.so.0
#   %{_libdir}/libobs-opengl.so.0.0
#   %{_libdir}/libobs.so.0
#   %{_libdir}/libobsglad.so.0
#   %{_prefix}/lib/obs-plugins
#   %{_datadir}/applications/obs.desktop
#   %{_datadir}/icons/hicolor/256x256/apps/obs.png
#   %{_datadir}/obs
#%doc README COPYING
%doc README
#%doc README COPYING UI/data/license/gplv2.txt
%license UI/data/license/gplv2.txt
%license COPYING
%{_bindir}/obs
%{_datadir}/applications/obs.desktop
%{_datadir}/icons/hicolor/256x256/apps/obs.png
%{_datadir}/obs/
%{_libexecdir}/obs-plugins/

%files libs
%{_libdir}/obs-plugins/
%{_libdir}/*.so.*

%files devel
#   %{_includedir}/obs
#   %{_libdir}/libobs.so
#   %{_libdir}/libobs-opengl.so
#   %{_libdir}/libobsglad.so
%{_libdir}/cmake/LibObs/
%{_libdir}/*.so
%{_includedir}/obs/

%files doc
%doc docs/html

%changelog
* Sun Mar 19 2017 Tomasz Tomasik <scx.mail@gmail.com> - 18.0.1-2
- Updated to 18.0.1
- Fixed requirements
- Fixed cmake command
- Change installation prefix from /usr/local to /usr
- Added support for EL7
- Added changes for (open)SUSE
- Built for EL7

* Wed Mar 8 2017 Momcilo Medic <fedorauser@fedoraproject.org> - 18.0.1-1
- Updated to 18.0.1

* Wed Mar 1 2017 Momcilo Medic <fedorauser@fedoraproject.org> - 18.0.0-1
- Updated to 18.0.0

* Mon Jan 30 2017 Momcilo Medic <fedorauser@fedoraproject.org> - 17.0.2-2
- Reintroduced obs-ffmpeg-mux.patch
- Fixes #4436

* Wed Jan 18 2017 Momcilo Medic <fedorauser@fedoraproject.org> - 17.0.2-1
- Updated to 17.0.2

* Tue Jan 03 2017 Momcilo Medic <fedorauser@fedoraproject.org> - 17.0.0-1
- Upstream fixed arch-dependent-file-in-usr-share
- Removed obs-ffmpeg-mux.patch
- Updated to 17.0.0

* Sun Nov 27 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.16.6-1
- Updated to 0.16.6

* Tue Nov 08 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.16.5-1
- Updated to 0.16.5

* Tue Oct 18 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.16.2-2.20161018git4505d5a
- Updated to git to resolve unversioned shared object
- Identified speexdsp-devel as a dependency

* Sat Oct 01 2016 Martin Gansser <martinkg@fedoraproject.org> - 0.16.2-1
- Updated to 0.16.2
- Build doxygen html documentation
- Added BR doxygen

* Fri Aug 26 2016 Leigh Scott <leigh123linux@googlemail.com> - 0.15.4-3
- Actually define FFMPEG_MUX_FIXED (fixes 'command not found' when trying to record)

* Sat Aug 13 2016 Leigh Scott <leigh123linux@googlemail.com> - 0.15.4-2
- Disable build for ARM (Arm gcc has no xmmintrin.h file)

* Fri Aug 12 2016 Leigh Scott <leigh123linux@googlemail.com> - 0.15.4-1
- Fix release tag (0.x release is for git releases)

* Mon Aug 08 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.15.4-0.1
- Updated to 0.15.4

* Fri Aug 05 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.15.2-0.5
- Added alsa-devel as BR for ALSA plugin.
- Added vlc-devel as BR for VLC plugin.
- Added systemd-devel as BR for Udev V4L.

* Wed Aug 03 2016 Leigh Scott <leigh123linux@googlemail.com> - 0.15.2-0.4
- Fix source tag (spectool now downloads in n-v format)
- Remove surplus ldconfig from postun (no public .so files in main package)
- Update scriptlets to meet guidelines (need full path)

* Wed Jul 20 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.15.2-0.3
- Added license file gplv2.txt

* Mon Jul 18 2016 Martin Gansser <martinkg@fedoraproject.org> - 0.15.2-0.2
- Fixed arch-dependent-file-in-usr-share
- Added obs-ffmpeg-mux.patch
- Added libs subpkg
- Call ldconfig in post(un) scripts for the shared library

* Sat Jul 16 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.15.2-0.1
- Updated to 0.15.2

* Sun Jul 10 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.15.1-0.1
- Updated to 0.15.1

* Sat Jul 09 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.15.0-0.1
- Updated to 0.15.0

* Mon May 16 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.14.2-0.1
- Updated to 0.14.2

* Mon Apr 25 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.14.1-0.1
- Updated to 0.14.1

* Sun Apr 24 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.14.0-0.1
- Updated to 0.14.0

* Tue Mar 22 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.13.4-0.1
- Updated to 0.13.4

* Sun Mar 20 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.13.3-0.1
- Updated to 0.13.3

* Tue Feb 23 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.13.2-0.1
- Updated to 0.13.2

* Sat Feb 06 2016 Momcilo Medic <fedorauser@fedoraproject.org> - 0.13.1-0.1
- Updated to 0.13.1

* Sun Dec 20 2015 Martin Gansser <martinkg@fedoraproject.org> - 0.12.4-0.2
- replace OBS_MULTIARCH_SUFFIX by LIB_SUFFIX

* Sat Dec 12 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.12.4-0.1
- Updated to 0.12.4

* Sat Dec 05 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.12.3-0.1
- Updated to 0.12.3

* Sat Nov 21 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.12.2-0.1
- Updated to 0.12.2

* Thu Nov 19 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.12.1-0.1
- Updated to 0.12.1

* Thu Sep 24 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.12.0-0.1
- Updated to 0.12.0

* Mon Aug 17 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.11.4-0.1
- Added OBS_VERSION_OVERRIDE to correct version in compilation
- Updated to 0.11.4

* Sat Aug 08 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.11.3-0.1
- Updated to 0.11.3

* Thu Jul 30 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.11.2-0.1
- Updated to 0.11.2

* Fri Jul 10 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.11.1-0.1
- Updated to 0.11.1

* Wed May 27 2015 Momcilo Medic <fedorauser@fedoraproject.org> - 0.10.1-0.1
- Initial .spec file
